classification
Title: Can't run Python Launcher on Windows
Type: behavior Stage: resolved
Components: Windows Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: steve.dower Nosy List: BreamoreBoy, paul.moore, python-dev, steve.dower, terry.reedy, tim.golden, zach.ware
Priority: normal Keywords:

Created on 2015-09-13 22:44 by BreamoreBoy, last changed 2016-01-16 20:01 by steve.dower. This issue is now closed.

Files
File name Uploaded Description Edit
Python 3.5.0 (64-bit)_20150913191600.log BreamoreBoy, 2015-09-14 13:44 Main log file as requested.
Python 3.5.0 (64-bit)_20151207124434_000_launcher_AllUsers.log BreamoreBoy, 2015-12-07 19:19 The only launcher log in the directory.
Messages (19)
msg250588 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-09-13 22:44
I first asked a few days ago, see this thread http://www.gossamer-threads.com/lists/python/python/1216917.  You can work around it by running "repair" but it takes an age to run for what, to me anyway, is a minor irritant.
msg250591 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-09-14 00:15
I don't understand what you did and what the result was from that thread.

* What options did you select when installing 3.5?
* What other Python versions did you have? What options were used to install them?
* Where was py.exe before installing 3.5?
* Can you attach all of the logs from your 3.5 install (from your %TEMP%)?
msg250592 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2015-09-14 01:29
For anyone else reading this, Mark says he already re-tried with 3.5.0.

The only problem I had with the install on my Win7, with 2.7.10, 3.4.3, and 3.5.0rc3 already present, is that 3.4.3 is still the default python (started by 'python') in spite of checking everything relevant when installing 3.5.0.
msg250594 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-09-14 02:27
Yeah, it's basically impossible to manage PATH automatically. You've probably installed 3.5 just for yourself while 3.4 is installed for all users. In this case, 3.5 will always lose because Windows puts user paths after system paths.

You could modify 3.4 to remove it from PATH or use py.exe, which resolves versions correctly. Or you can modify your PATH manually.
msg250604 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2015-09-14 03:52
I did installed 3.5 for all users.  Logging into another user and back changed 'python' association. So ok now.
msg250611 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-09-14 04:22
I install for all users, don't put Python on the PATH, other than that I think everything is selected.

I've 2.6, 2.7. 3.3 and 3.4.  I had 3.5.0rc4 and upgraded the existing installation to 3.5.0 full release.

I've no idea where py.exe was, but it is now in C:\Windows.  This is what I expect having just read PEP397.

Do you really want all logs from the 3.5.0 install and the repair, that's 21 files?  It's an odd number as there is no log file for the launcher in the install but there is in the repair.  The same is true for the rc4 logs.
msg250664 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-09-14 13:32
Just the main log file from the initial install is enough if there's no log for the launcher. It probably means the initial setup startup deselected it for some reason.
msg250670 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-09-14 15:31
Yep, as part of the upgrade detection we're choosing not to install the launcher. Not sure whether that's because of a bug or a previous install on your machine, but I'll take a closer look.
msg252555 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2015-10-08 17:01
New changeset 1e99ba6b7c98 by Steve Dower in branch '3.5':
Issue #25089: Adds logging to installer for case where launcher is not selected on upgrade.
https://hg.python.org/cpython/rev/1e99ba6b7c98
msg252556 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-10-08 17:02
Hopefully with the extra logging we'll be able to see if something is failing at the point of detection. Any failure here (permissions in registry, etc.) will cause the launcher to not be installed on upgrade (which might be the same as removing it... I need to spend more time working through the dependencies involved here because they are messy).
msg256064 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-12-07 19:19
After running the 3.5.1 64 bit web installer the py launcher has again been lost, i.e. "'py' is not recognized as an internal or external command, operable program or batch file."  Running the web installer in "repair" mode hasn't made any difference.  I've attached the log file for the removal of the 3.5.0 launcher, but there are no launcher files with the 3.5.1 install or repair.
msg256069 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-12-07 21:15
There's a separate issue in the 3.5.1 installer where the launcher is always deselected on upgrade. I'm currently working on a fix to force it to always install and we might push out a new 3.5.1 build later today.

If you go through Modify rather than Repair then you can select to install the launcher.
msg256080 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-12-07 22:20
Using "modify" rather than "repair" fixed the launcher issue, a pity about this.

py
Python 3.5.1 (v3.5.1:37a07cee5969, Dec  6 2015, 01:54:25) [MSC v.1900 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license" for more information.
>>> import tkinter
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
ImportError: No module named 'tkinter'
>>>

I only selected launcher as that was the only thing I expected to be modified.  However the modify also took an age as I recall seeing loads of stuff about test files.  You might gather that I'm extremely confused about the entire process, so exactly what is going on here?
msg256086 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-12-07 23:17
Did you deselect everything else? That will remove it all.
msg256088 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-12-07 23:21
Of course I deselected everything, the only thing I wanted modified was the launcher, I wanted everything else left alone.
msg256095 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2015-12-08 00:04
The convention when modifying installations is to specify the end-state that you're want, so unchecking something indicates that you want to remove it.

This could be made clearer, but it's probably a significant redesign of the UI. At the least we could specify in the text how it works, but in my experience most people don't read that anyway. (If you did read it, let me know as that's a good data point in favour of doing it.)
msg256100 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2015-12-08 01:12
If by "in the text" you mean here https://docs.python.org/3/using/windows.html then yes please, as I find a few minutes of RTFM can save hours of wasted time.
msg258403 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2016-01-16 19:59
New changeset 5fc9bd33a712 by Steve Dower in branch '3.5':
Issue #25089: Adds short documentation section for modifying an install.
https://hg.python.org/cpython/rev/5fc9bd33a712

New changeset 4b06490cca47 by Steve Dower in branch 'default':
Issue #25089: Adds short documentation section for modifying an install.
https://hg.python.org/cpython/rev/4b06490cca47
msg258404 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2016-01-16 20:01
I've added a brief doc section on modifying and removing the install, so hopefully that suffices for this issue. If the original issue occurs again, feel free to reopen, but I think it'll be okay.

I have a few ideas about changing the installer to be more intuitive, but those would be separate.
History
Date User Action Args
2016-01-16 20:01:31steve.dowersetstatus: open -> closed
resolution: fixed
messages: + msg258404

stage: resolved
2016-01-16 19:59:41python-devsetmessages: + msg258403
2015-12-08 01:12:15BreamoreBoysetmessages: + msg256100
2015-12-08 00:04:24steve.dowersetmessages: + msg256095
2015-12-07 23:21:02BreamoreBoysetmessages: + msg256088
2015-12-07 23:17:51steve.dowersetmessages: + msg256086
2015-12-07 22:20:06BreamoreBoysetmessages: + msg256080
2015-12-07 21:15:19steve.dowersetmessages: + msg256069
2015-12-07 19:19:24BreamoreBoysetfiles: + Python 3.5.0 (64-bit)_20151207124434_000_launcher_AllUsers.log

messages: + msg256064
2015-10-08 17:02:44steve.dowersetmessages: + msg252556
2015-10-08 17:01:25python-devsetnosy: + python-dev
messages: + msg252555
2015-09-14 15:31:14steve.dowersetassignee: steve.dower
messages: + msg250670
2015-09-14 13:44:50BreamoreBoysetfiles: + Python 3.5.0 (64-bit)_20150913191600.log
2015-09-14 13:32:25steve.dowersetmessages: + msg250664
2015-09-14 04:22:20BreamoreBoysetmessages: + msg250611
2015-09-14 03:52:03terry.reedysetmessages: + msg250604
2015-09-14 02:27:47steve.dowersetmessages: + msg250594
2015-09-14 01:29:52terry.reedysetnosy: + terry.reedy
messages: + msg250592
2015-09-14 00:15:22steve.dowersetmessages: + msg250591
2015-09-13 22:44:57BreamoreBoycreate